package NsPuzzle;
import edu.uci.ics.pattis.ics23.collections.*;
import java.util.Comparator;
import stateSpace.*;

public class Application {

  public static void main(String[] args) { 
    NsPuzzle problem = new NsPuzzle (3,
        new int[][]{{1,2,3},
                    {4,0,5},
                    {6,7,8}},
        new int[][]{{1,0,2},
                    {4,7,5},
                    {8,6,3}}
        );
    
    System.out.println("Operators for problem");
    for (Problem.Operator o : problem.getAllOperators())
      System.out.println("  " + o);
    System.out.println();
    
    System.out.println("breadth first solution");
    List<NsPuzzle.Operator> solution = Solver.breadthFirstSolution(problem);
    System.out.println(Solver.illustrateSolution(problem.getStartState(),solution));

    System.out.println("\nbest first solution");
    solution = Solver.bestFirstSolution(problem, (Comparator<Problem.State>)problem.getMetric());
    System.out.println(Solver.illustrateSolution(problem.getStartState(),solution));
  }

}



/*
Problem from http://www.cut-the-knot.org/ctk/Water.shtml

Three men robbed a gentleman of a vase, containing 24 ounces of balsam.
Whilst running away they met a glass seller, of whom they purchased
three vessels. On reaching a place of safety they wished to divide the
booty, but found that their vessels could hold 5, 11, and 13 ounces respectively.
How could they divide the balsam into equal portions?

*/
