package waterJugs;


import edu.uci.ics.pattis.ics23.collections.*;
import stateSpace.*;



public class WaterJugs extends WaterJugsNoFillNoEmpty implements Problem {

  public WaterJugs (int[] jugSizes, int[] start, int[] stop) throws IllegalArgumentException {
    super(jugSizes,start,stop);
  }

  
  class Empty implements Problem.Operator {
    private int which;

    Empty (int which) {
      if (which<0 || which>=jugSizes.length)
        throw new IllegalArgumentException("WaterJugs(Empty): Illegal which ("+which+") not a legal jug #");
      this.which = which;
    }

    public Problem.State apply (Problem.State s) {
      WaterJugsNoFillNoEmpty.State answer = (WaterJugsNoFillNoEmpty.State)(s.copy());
      answer.jugState[which] = 0;
      return answer;
    }

    public String toString() {
      return "Empty jug " + (which+1);
    }

  }


  
  class Fill implements Problem.Operator {
    private int which;

    Fill (int which) {
      if (which<0 || which>=jugSizes.length)
        throw new IllegalArgumentException("WaterJugs(Fill): Illegal which ("+which+") not a legal jug #");
      this.which = which;
    }

    public Problem.State apply (Problem.State s) {
      WaterJugsNoFillNoEmpty.State answer = (WaterJugsNoFillNoEmpty.State)(s.copy());
      answer.jugState[which] = jugSizes[which];
      return answer;
    }

    public String toString() {
      return "Fill jug " + (which+1);
    }
  }


  
  public Set<WaterJugs.Operator> getAllOperators() {
    Set<WaterJugs.Operator> operators = new ArraySet<WaterJugs.Operator>();

    operators.addAll(super.getAllOperators()); //Transfer i->j (i!=j)

    //Empty/Fill i
    for (int i = 0; i < jugSizes.length; i++) {
      operators.add(new Empty(i));
      operators.add(new Fill(i));
    }

    return operators;
  }

}